/*
 * Project: MoleCuilder
 * Description: creates and alters molecular systems
 * Copyright (C)  2012 University of Bonn. All rights reserved.
 * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
 */

/*
 * KeyValueValidator.cpp
 *
 *  Created on: May 14, 2012
 *      Author: ankele
 */


// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "CodePatterns/MemDebug.hpp"

#include "KeyValueValidator.hpp"

bool KeyValueValidator::isValid(const std::string & _value) const
{
  size_t pos0 = _value.find("=");
  if (pos0 == std::string::npos)
    // No "=" found.
    return false;

  if (pos0 == 0)
    // Nothing before "=".
    return false;

  if (pos0 == _value.size() - 1)
    // Nothing after "=".
    return false;

  size_t pos1 = _value.find("=", pos0 + 1);
  if (pos1 != std::string::npos)
    // Second "=" found.
    return false;

  return true;
}

bool KeyValueValidator::operator==(const Validator<std::string> &_instance) const
{
  const KeyValueValidator *inst =
      dynamic_cast<const KeyValueValidator *>(&_instance);
  if (inst)
    return true;
  else
    return false;
}

Validator< std::string >* KeyValueValidator::clone() const
{
  Validator< std::string > *inst =
      new KeyValueValidator();
  return inst;
}




