/*
 * KeyValueValidator.hpp
 *
 *  Created on: May 10, 2012
 *      Author: heber
 */

#ifndef KEYVALUEVALIDATOR_HPP_
#define KEYVALUEVALIDATOR_HPP_


// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <string>

#include "Parameters/Validators/Validator.hpp"

/** This validator checks whether the given string is a valid key value
 * concatenation of the following pattern "...=...;"
 */
class KeyValueValidator : public Validator<std::string>
{
  bool isValid(const std::string & _value) const;
  bool operator==(const Validator<std::string> &_instance) const;
  Validator< std::string >* clone() const;
};


#endif /* KEYVALUEVALIDATOR_HPP_ */
